
/*

badaboum, UIseq++ ;

Version / 11 septembre 2010.

*/

// -------------------------------------------------------------------------------------------------------------

inlets = 1 ;
outlets = 2 ;

setinletassist	(0, "?") ;
setoutletassist (0, "notes_number, setcell, loop start, loop end") ;
setoutletassist (1, "recalled, resized, key_up") ;

autowatch = 1 ;
 
if (typeof tralala_pomme === "undefined")
    {
        tralala_pomme = [ ] ;           
    }            

// -------------------------------------------------------------------------------------------------------------
 
var js_name		= "je suis badaboum " + jsarguments[1], 
	noname		= 1 ;                                   
             
// -------------------------------------------------------------------------------------------------------------

var STEP			= 24,
	SEQ_BAR_LONG	= 60,						
	MAX_NOTES		= 256,						
	SCALE_X			= 5.,						
	SCALE_Y			= 2.,	
	MIDI			= 128,					
	SCALE_STEP		= (2 * SCALE_Y) / MIDI,
	TEMPO_CST		= 60000 / STEP,				
	TIME_STEP		= STEP * 4 ;				

// -------------------------------------------------------------------------------------------------------------

var window_size		= [500, 400],  
	full_size		= [1000, 800],  
	window_buffer	= [0, 44, 500, 444] ;
                                                                                                                                                                                                                    
var need_draw		= 0 ;     
                                                           
var camera_x		= 0.,
	camera_y		= 0.,
	camera_z		= 0.6 ;   

// -------------------------------------------------------------------------------------------------------------

var mylistener					= new JitterListener (js_name, callback) ;

var myrender					= new JitterObject ("jit.gl.render", js_name) ;
    myrender.erase_color		= [1., 1., 1., 1.] ;
    myrender.blend_enable		= 1 ;
    myrender.depth_enable		= 0 ;
    myrender.ortho				= 0 ;

var mygrid						= new JitterObject ("jit.gl.gridshape", js_name) ;     
    mygrid.shape				= "plane" ;
    mygrid.scale				= [SCALE_X, SCALE_Y] ;                                                              
    mygrid.blend_enable			= 1 ;   
    mygrid.depth_enable			= 0 ;                                         
    mygrid.poly_mode			= [1, 1] ;
    mygrid.color				= [0.8, 0.8, 0.8, 0.1] ;
    mygrid.automatic			= 0 ;
    mygrid.time_sig				= [4, 4] ;
    mygrid.snap					= 1 ;
    mygrid.ternaire				= 0 ;

var mybar						= new JitterObject ("jit.gl.gridshape", js_name) ;
    mybar.shape					= "plane" ;
    mybar.depth_enable			= 0 ;
	mybar.blend_enable			= 1 ;
    mybar.scale					= [SCALE_X, SCALE_Y] ;
    mybar.poly_mode				= [1, 1] ;
    mybar.color					= [0.7, 0.7, 0.7, 0.1] ;
    mybar.automatic				= 0 ;
    mybar.time_sig				= [4, 4] ;

var mytitle						= new JitterObject ("jit.gl.text2d", js_name) ;
    mytitle.blend_enable		= 1 ;
    mytitle.depth_enable		= 0 ;
    mytitle.color				= [0.83, 0.74, 0.84, 1.] ;
    mytitle.position			= [0., 0., 0.] ;
    mytitle.align				= 1 ;
    mytitle.font				("Comic Sans MS") ;
    mytitle.size				(48) ;
    mytitle.automatic			= 0 ;
	mytitle.displayed			= 1 ;
	mytitle.myname				= " " ;
    
var myinfo						= new JitterObject ("jit.gl.text2d", js_name) ;
    myinfo.blend_enable			= 1 ;
    myinfo.depth_enable			= 0 ;
	myinfo.automatic			= 0 ;
    myinfo.color				= [0.83, 0.74, 0.84, 0.] ;
    myinfo.align				= 1 ;
    myinfo.font					("Comic Sans MS") ;
    myinfo.size					(36) ;
    
var mypaint_position			= new JitterMatrix (2, "float32") ;
	mypaint_position.name		= "position" + js_name ;
	
var mypaint_scale				= new JitterMatrix (2, "float32") ;
	mypaint_scale.name			= "scale" + js_name ;
	
var mypaint_color				= new JitterMatrix (4, "float32") ;
	mypaint_color.name			= "color" + js_name ;

var mypaint_multiple				= new JitterObject ("jit.gl.multiple") ;
	mypaint_multiple.drawto			= js_name ;
	mypaint_multiple.glparams		= ["position", "scale", "color"] ;
	mypaint_multiple.targetname		= "moi" + js_name ;
	mypaint_multiple.automatic		= 0 ;
	
var mypaint_nothing					= new JitterObject ("jit.gl.gridshape", js_name) ;
    mypaint_nothing.shape			= "plane" ;
	mypaint_nothing.name			= "moi" + js_name ;
    mypaint_nothing.depth_enable	= 0 ;
	mypaint_nothing.lighting_enable = 0 ;
	mypaint_nothing.blend_enable	= 1 ;
    mypaint_nothing.dim				= [1, 1] ;
	mypaint_nothing.line_width		= 2 ;
    mypaint_nothing.automatic		= 0 ;	

// -------------------------------------------------------------------------------------------------------------

var mouse = {                        
	avoid_up	: 0,                  
	hit			: 0,                                                                     
	where		: 0,                     
	moving		: 0
	} ;                   

var	creating = {       
	state	: 0,                      
	block	: 0,                   
	} ;
        
var key = { 
	swap		: 0,                                                        
    snap		: 1,                                  
    pitch		: 0, 
	position	: 0,
    un			: 0,                                
    deux		: 0,
    trois		: 0,
    quatre		: 0,  
	esc			: 0
	} ;        

var ghost = { 
	zut			: [ ], 
	start		: undefined,
	coordinates : [undefined, undefined] 
	} ; 
																									
var seq = { 
	zut				: [ ], 
    midi_channel	: 1,
    tempo			: 120,
	coordinates		: [undefined, undefined],
	factor			: 1,
	buffer			: null,                       
    lasso_x			: null,
    lasso_y			: null,
    lasso_u			: null,
    lasso_v			: null,
	lasso_state		: 0, 
    lasso_block		: 0
	} ;

	seq.zut[0] = new Shape (min_snap (-0.1), SCALE_Y, min_snap (0.1), -SCALE_Y, 0.1, 0, 0, 0, 0, 0) ; 
	seq.zut[0].select_right = 0 ;
	seq.zut[0].select_left	= 0 ;   

// -------------------------------------------------------------------------------------------------------------

var right			= new Task (move_camera_right, this),
	left			= new Task (move_camera_left, this),
	up				= new Task (move_camera_up, this),
	down			= new Task (move_camera_down, this),
	zoom			= new Task (move_camera_zoom, this),
	unzoom			= new Task (move_camera_unzoom, this) ;

var slow_notify		= new Task (notifyclients, this),                           
	slow_set		= new Task (set_matrix, this),
	slow_unpaste	= new Task (unpaste_mytitle, this) ;

// -------------------------------------------------------------------------------------------------------------

myrender.keep_inside = function (x, y)
	{
		var k = this.screentoworld (x, y) ;
		
		if (k[0] < -SCALE_X)  { k[0] = -SCALE_X ; }
		if (k[0] >  SCALE_X)  { k[0] = SCALE_X ;  }
		if (k[1] < -SCALE_Y)  { k[1] = -SCALE_Y ; }
		if (k[1] >  SCALE_Y)  { k[1] = SCALE_Y ;  }
		
		return k ;		
	} ;
	
// -------------------------------------------------------------------------------------------------------------

mybar.set_bar = function ()
    {
        var x = this.time_sig[1] * SEQ_BAR_LONG ;
		var y = 1 ;
		
        if (SEQ_BAR_LONG % this.time_sig[0] === 0)                                 
            { 
				y = x / this.time_sig[0] ;
			}                                                   
			                                                       
        this.dim = [y + 1, 33] ;  
    } ;

// -------------------------------------------------------------------------------------------------------------

mygrid.set_grid = function ()
    { 
       var x = this.time_sig[1] * SEQ_BAR_LONG ;                                                      
       this.dim = [x + 1, 129] ; 
    } ;

mygrid.z_test = function (a) 
    { 
        if (a > 1.2) 
            { 
				this.color = [0.8, 0.8, 0.8, 0.] ;
			}
        else
            { 
				this.color = [0.8, 0.8, 0.8, 0.1] ; 
			}
    } ;

// -------------------------------------------------------------------------------------------------------------

mytitle.show = function ()
    {
		if (this.color[3] === 0.)
			{
       			 this.color = [0.83, 0.74, 0.84, 1.] ;
			}
    } ;

mytitle.hide = function ()
    {
		if (this.color[3] === 1.)
			{
        		this.color = [0.83, 0.74, 0.84, 0.] ;
			}
    } ;
	
// -------------------------------------------------------------------------------------------------------------
		 
myinfo.show = function ()
    {
		if (this.color[3] === 0.)
			{
        		this.color = [0.83, 0.74, 0.84, 1.] ;
			}
    } ;

myinfo.hide = function ()
    {
		if (this.color[3] === 1.)
			{
        		this.color = [0.83, 0.74, 0.84, 0.] ;
				this.text (" ") ;
			}
    } ;	 
	
myinfo.paste = function (x, y, what, shape)                                                       
    {
        var a		= Math.floor ((((snap_up (y) + snap_down (y)) / 2.) + SCALE_Y) / SCALE_STEP) ;  
        var b		= (Math.floor (a / 12)) - 2 ;                                             
        var c		= a % 12 ;                                                                    
        var txt		= "?";
        var e		= 0.03 * camera_z ;
        var f		= 0.01 * camera_z ;
		var g		= " ";
		
		if (key.position)
			{
				g = "/" + Math.round (((snap_grid (x, "left") + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X)) ;
			}
		
		switch (what) {
			case "alpha"	:	txt = Math.round (shape[what] * MIDI) ; break ; 
			case "channel"	:	txt = shape[what] ; break ; 
			case "un"		:	txt = shape[what] ; break ; 
			case "deux"		:	txt = shape[what] ; break ; 
			case "trois"	:	txt = shape[what] ; break ; 
			case "pitch"	:	switch (c) {
									case 0	: txt = "C" + b + g ; break ;
									case 1	: txt = "C#" + b + g ; break ;
									case 2	: txt = "D" + b + g ; break ;
									case 3	: txt = "D#" + b + g ; break ;
									case 4	: txt = "E" + b + g ; break ;
									case 5	: txt = "F"+ b + g ; break ;
									case 6	: txt = "F#" + b + g ; break ;
									case 7	: txt = "G" + b + g ; break ;
									case 8	: txt = "G#" + b + g ; break ;
									case 9	: txt = "A" + b + g ; break ;
									case 10 : txt = "A#" + b + g ; break ;
									case 11 : txt = "B" + b + g ; break ; 
									} 
								break ;
			} 
			
		this.position = [x - e, y + f, 0.] ;
        this.text (txt) ; 
    } ;

// -------------------------------------------------------------------------------------------------------------

key.reset = function ()
	{   
		this.un = 0 ;                             
		this.deux = 0 ;
		this.trois = 0 ;
		this.quatre = 0 ;
	} ;			        							   
             
// -------------------------------------------------------------------------------------------------------------

seq.add_note = function (position, pitch, velocity, duration, channel)	
	{
		var x		= min_snap ((((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * position) - SCALE_X) ;        
        var u		= min_snap (x + (((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * duration)) ;   
        var y		= (SCALE_STEP * (pitch + 1)) - SCALE_Y ;                                
        var v		= (SCALE_STEP * pitch) - SCALE_Y ;
        var alpha	= (velocity / MIDI) ;
        var w ;
        
        if (!channel || channel > 16)
            { w = this.midi_channel ; }
        else
            { w = channel ; }

		if (this.zut.length < MAX_NOTES)
			{
				this.zut[this.zut.length] = new Shape (x, y, u, v, alpha, 1, w, 0, 0, 0) ;
				this.zut[this.zut.length - 1].keep_inside () ;
				this.zut[this.zut.length - 1].paint_values () ;
			}     
	} ;
		
seq.add_shape = function (s)	
	{
		this.zut[this.zut.length] = new Shape (s.x, s.y, s.u, s.v, s.alpha, 1, s.channel, s.un, s.deux, s.trois) ;
		this.zut[this.zut.length - 1].paint_values () ;
	} ;
	
seq.clear = function ()
	{
		this.zut.splice (1, this.zut.length - 1) ;
	} ;	
	                                          
seq.change_selected = function (what, step, mouse_now, equal, k)
    {
		var i, len ;
		
		for (i = 1, len = this.zut.length ; i < len ; i++)
            {
				if (this.zut[i].select && this.buffer)
					{
						if (mouse_now > this.buffer)
                            { 
								this.zut[i][what] += step ;
							}
                        else
                            { 
								this.zut[i][what] -= step ; 
							} 	
							
						if (what === "channel")
                   			{
                        		if (this.zut[i][what] < 1)
                            		{ 
										this.zut[i][what] = 1 ; 
									}
                         		if (this.zut[i][what] > 16)
                            		{
										this.zut[i][what] = 16 ; 
									}
                    		}	
							
                		if (what === "alpha")
                    		{
                        		if (this.zut[i][what] > MIDI - 1 / MIDI)
                            		{ 
										this.zut[i][what] = MIDI - 1 / MIDI ; 
										this.zut[i].paint_values () ;
									}
									
                        		if (this.zut[i][what] < 0.)
									{ 
										this.zut[i][what] = 0. ;
										this.zut[i].paint_values () ;
									}
                    		}      
					}		
			}  
			 	
		if (equal)
			{
				for (i = 1, len = this.zut.length ; i < len ; i++)
					{
						if (this.zut[i].select && this.buffer)
							{
								this.zut[i][what] = this.zut[k][what] ;
								
								if (what === "alpha")
									{
										this.zut[i].paint_values () ;
									}
							}
					}
			}	
	} ;
   	                                                  
seq.delete_selected = function ()
    {
		var temp = [ ] ;
		var i ;

        for (i = this.zut.length - 1 ; i > 0 ; i--)
            {  
                if (this.zut[i].select) 
					{
						temp.push (i) ;
					}                                                                       
            }
			
		for (i in temp) 
			{
				this.zut.splice (temp[i], 1) ;
			}
    } ;
	
seq.unselect_all = function ()                                                     
    {
		var i, len ;
		
        for (i = 1, len = this.zut.length ; i < len ; i++)
            {
                this.zut[i].select = 0 ;
            }
    } ;

seq.select_all = function ()
	{
		var i, len ;
	
		for (i = 1, len = this.zut.length ; i < len ; i++)
            {
                this.zut[i].select = 1 ;
            }
	} ;    
	
seq.exist_selected = function ()
	{
		var k = 0 ;
		var i, len ;
		
		for (i = 1, len = this.zut.length ; i < len ; i++)   
			{
				if (this.zut[i].select)
					{
						k = 1 ;
						break ;
					}
			}
			
		return k
	} ;
	
seq.lasso_select = function ()
	{
		var h, k, l, m ;
		var o, p, match_x, match_y ;
		var i, len ;
		
		if (this.lasso_x < this.lasso_u)
			{
				h = this.lasso_x ;
				l = this.lasso_u ;
                                        
				if (this.lasso_y > this.lasso_v)
					{ 
						k = this.lasso_y ;
						m = this.lasso_v ; 
					}
               	else
					{
						k = this.lasso_v ;
						m = this.lasso_y ;
					}
			}
		else
			{
				h = this.lasso_u ;
				l = this.lasso_x ;
                                        
				if (this.lasso_y > this.lasso_v)
					{
						k = this.lasso_y ;                                               
						m = this.lasso_v ; 
					}
				else
					{
						k = this.lasso_v ;                                               
						m = this.lasso_y ; 
					}
			}                  
		
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				o		= (this.zut[i].x + this.zut[i].u) / 2 ;          
				p		= (this.zut[i].y + this.zut[i].v) / 2 ;          
				match_x = 0 ;
				match_y = 0 ;
				
				if (o > h && o < l)
					{ 
						match_x = 1 ; 
					}
                 
				if (p > m && p < k)
					{ 
						match_y = 1 ;
					}
                                       
				if (match_x && match_y)
					{ 
						this.zut[i].net = 1 ;
					} 	
			}
	} ;

seq.lasso_reverse = function ()
	{
		var i, len ;
		
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				if (this.zut[i].net)
					{
						this.zut[i].select = !this.zut[i].select ;
						this.zut[i].net = 0 ;
					}
			}
	} ;
							   		                                               	
seq.to_pomme = function ()
    {
		var i, len ;
		var k = [ ] ;
		
		this.compute_delta () ;

        for (i = 1, len = this.zut.length ; i < len ; i++)
            {
				if (this.zut[i].select)
					{
						k.push (this.zut[i]) ;
				 	}
            }
		
		return k
    } ;

seq.from_pomme = function (k)
	{
		var x, y, u, v, alpha, channel, un, deux, trois ;
		var i ;
	
        for (i in k) 
			{
				x		= this.coordinates[0] + k[i].delta_x ;                                        
				y		= snap_up (this.coordinates[1] + k[i].delta_y) ;
				u		= this.coordinates[0] + k[i].delta_u ;
				v		= snap_up (this.coordinates[1] + k[i].delta_v) ;                                                                       
				alpha	= k[i].alpha ;
				channel = k[i].channel ; 
                un		= k[i].un ;
                deux	= k[i].deux ;
                trois	= k[i].trois ;
                
                if (this.zut.length < MAX_NOTES)
                	{
                    	this.zut[this.zut.length] = new Shape (x, y, u, v, alpha, 1, channel, un, deux, trois) ;
						this.zut[this.zut.length - 1].keep_inside () ;
						this.zut[this.zut.length - 1].paint_values () ;
                    }
			}
	} ;

seq.translate_zone = function ()
    {
        var k = [undefined, undefined] ;
		var a = this.zut[0].x ;
        var b = this.zut[0].u ;

        k[0] = Math.round (((a + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X)) ;           
        k[1] = (Math.round (((b + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X))) - 1 ; 

        return k ;     
    } ;

seq.translate_shape = function (p)                                              
    {
        var a, b, c, d, e, f ;
        var k = [ ] ;

        a = Math.round (((this.zut[p].x + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X)) ;
        b = Math.round (((this.zut[p].u + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X)) ;
        e = b - a ;
        c = Math.floor ((((this.zut[p].y + this.zut[p].v) / 2) + SCALE_Y) / SCALE_STEP) ;  
        d = Math.round (this.zut[p].alpha * MIDI) ;
        f = a + e ;
        k = [a, c, d, e, this.zut[p].channel, this.zut[p].un, this.zut[p].deux, this.zut[p].trois, f] ;   
        
        return k ;
    } ;
		
seq.is_hit = function (x, y)
	{
		var k = [null, null] ;
		var match_x , match_y ;
		var i ;
		
		for (i = (this.zut.length - 1) ; i > 0 ; i--)
			{    
				match_x = 0 ;
				match_y = 0 ;
				
				if (x > this.zut[i].x && x < this.zut[i].u)
                	{ 
						match_x = 1 ;
					}

                if (y > this.zut[i].v && y < this.zut[i].y)
                	{
						match_y = 1 ;
					}
                                        
				if (match_x && match_y)
					{
						k[1] = i ;

						if (this.zut[i].select)
							{
								k[0] = "selected" ;	
							}	
						else
							{
								k[0] = "unselected" ;
							}
						
						break ;
					}	
			}	
			
		return k
	} ;
	
seq.compute_delta = function ()
	{
		var i, len ;
	
		for (i = 1, len = this.zut.length ; i < len ; i++)
            {
				if (this.zut[i].select)
					{
						this.zut[i].delta_x = this.zut[i].x - this.coordinates[0] ;
						this.zut[i].delta_y = this.zut[i].y - this.coordinates[1] ;
						this.zut[i].delta_u = this.zut[i].u - this.coordinates[0] ;
						this.zut[i].delta_v = this.zut[i].v - this.coordinates[1] ;
				 	}
            }
	} ;

seq.move_selected = function (x, y, snap)
	{
		var h, k, l, n, o ;
		var i, len ;
	
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				if (this.zut[i].select)
					{
						h = ((this.zut[i].delta_y + this.zut[i].delta_v) / 2) ;
						
						k = x + this.zut[i].delta_x ;
						l = x + this.zut[i].delta_u ;
						n = snap_grid (k) ;
                        o = k - n ;                                                
                                
						if (snap)
							{                                                                          
								this.zut[i].x = n ;
								this.zut[i].u = min_snap (l - o) ;          
								this.zut[i].y = snap_up (h + y) ;
								this.zut[i].v = snap_down (h + y) ;
							}
						else
							{
								this.zut[i].x = min_snap (k) ;
								this.zut[i].u = min_snap (l) ;
								this.zut[i].y = snap_up (h + y) ;
								this.zut[i].v = snap_down (h + y) ;
							}
						
						this.zut[i].keep_inside () ;
						this.zut[i].paint_values () ;
					}
			}
	} ;

seq.resize_selected = function (x, snap)
	{
		var k ;
		var i, len ;
		
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				if (this.zut[i].select)
					{
						k = (2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP) ;
					
						if (snap)
							{
								if (snap_grid (x + this.zut[i].delta_u) > this.zut[i].x + k)
                            		{ 
                               			this.zut[i].u = snap_grid (x + this.zut[i].delta_u) ;
                            		}
							}
						else
							{
								if (min_snap (x + this.zut[i].delta_u) > this.zut[i].x + k)
                            		{ 
                               			this.zut[i].u = min_snap (x + this.zut[i].delta_u) ;
                            		}
							}
						
						this.zut[i].paint_values () ;
					}	
			}
	} ;
	
seq.whois_mark = function ()
	{
		var k = -1 ;
		var i, len ;

		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				if (this.zut[i].mark)
					{
						k = i ;
						break ;
					}
			}
			
		return k ;
	} ;

seq.unmark = function ()
	{
		var i, len ;
		
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				if (this.zut[i].mark)
					{
						this.zut[i].mark = 0 ;
					}
			}	
	} ;

seq.reset = function ()
	{
		var i, len ;
	
		for (i = 1, len = this.zut.length ; i < len ; i++)
			{
				this.zut[i].channel = this.midi_channel ;
				this.zut[i].un		= 0 ;
				this.zut[i].deux	= 0 ;
				this.zut[i].trois	= 0 ;
			}	
	} ;
			
// -------------------------------------------------------------------------------------------------------------

ghost.add = function (position, pitch, velocity, duration, channel, un, deux, trois)
	{
		var x, u, y, v, z, w ;
					
		x = min_snap ((((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * position) - SCALE_X) ;        
        u = min_snap (x + (((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * duration)) ;
		y = (SCALE_STEP * (pitch + 1)) - SCALE_Y ;                                
        v = (SCALE_STEP * pitch) - SCALE_Y ;	
        z = (velocity / MIDI) ; 
		w = channel ;    
       
        if  (x >= -SCALE_X && u <= SCALE_X && y <= SCALE_Y && v >= -SCALE_Y)
            {
                this.zut[this.zut.length] = new Shape (x, y, u, v, z, 0, w, un, deux, trois) ;
				this.zut[this.zut.length - 1].paint_values () ;
            }
	} ;

ghost.match = function (a)
	{
		var k = 0 ;
		var i ;
		
		for (i in this.zut)                                                
			{
				if (a >= this.zut[i].x && a < this.zut[i].u)
					{
						if (!this.zut[i].select && (this.zut[i].x - this.start >= -0.001))
							{
								this.zut[i].select = 1;
								k = 1 ;
							}
					}
				else 
					{
						if (this.zut[i].select) 
							{
								this.zut[i].select = 0 ;
								k = 1 ;
							}
					}
			}	
					
		return k ;
	} ;
	
ghost.clear = function ()
	{
		this.zut.splice (0, this.zut.length)
	} ;

ghost.unselect_all = function ()
	{
		var i ;
	
		for (i in this.zut)
			{
				this.zut[i].select = 0 ;
			}
	} ;
	
ghost.to_pomme = function ()
    {
        var k = [ ] ;
		var i ;

        for (i in this.zut)
            {
                this.zut[i].delta_x = this.zut[i].x - this.coordinates[0] ;     
                this.zut[i].delta_y = this.zut[i].y - this.coordinates[1] ;
                this.zut[i].delta_u = this.zut[i].u - this.coordinates[0] ;
                this.zut[i].delta_v = this.zut[i].v - this.coordinates[1] ;
                
                k.push (this.zut[i]) ;
            }
		
		return k ;
    } ;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

Shape.local = 1 ;
function Shape (x, y, u, v, alpha, select, channel, un, deux, trois) 
    { 
        this.x			= x ;
        this.y			= y ;
        this.u			= u ;
        this.v			= v ;
        this.alpha		= alpha ;
        this.select		= select ;
        this.channel	= channel ;                    
        this.un			= un ;
        this.deux		= deux ;
        this.trois		= trois ;
		this.net		= undefined ;
		this.mark		= undefined ;
	}
	
Shape.prototype.sort = function ()
	{
		var a = this.x ;                                               
		var b = this.u ;
		var c = Math.abs (b - a) ;
		var d = (2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP) ;

		if (a > b) 
			{ 	
				this.x = b ;
				this.u = a ;
			}
			
		if (c < d)               
			{ 
				this.u = this.x + d ;
			}
	} ;
		
Shape.prototype.keep_inside = function ()
	{
		var q = this.x + SCALE_X     
		var r = this.y - SCALE_Y
		var s = this.u - SCALE_X
		var t = this.v + SCALE_Y

		if (q < 0.)
			{ 
				this.x -= q ;
				this.u -= q ; 
			}
			
		if (r > 0.)
			{ 
				this.y -= r ;
				this.v -= r ; 
			}
			
		if (s > 0.)
			{ 
				this.x -= s ;
				this.u -= s ; 
			}
			
		if (t < 0.)
			{
				this.y -= t ;
				this.v -= t ; 
			}
	} ;

Shape.prototype.paint_values = function ()
	{
		var color_number, alpha, color ;
		
		this.a = (this.x + this.u) / 2. ;
		this.b = (this.y + this.v) / 2. ;
		this.c = (this.u - this.x) / 2. ;
		this.d = (this.v - this.y) / 2.	;
				
		if (this.alpha < 0.1)
            {
                alpha = 0.1 ;
            }
        else
            {
                alpha = this.alpha ;
            }

		color_number = Math.floor ((((this.y + this.v) / 2.) + SCALE_Y) / SCALE_STEP) % 12 ;
				
		switch (color_number) {   
			case 0	: color = [0.83, 0.74, 0.84, alpha] ; break ;                
			case 1	: color = [0.62, 0.55, 0.83, alpha] ; break ;
			case 2	: color = [0.83, 0.36, 0.54, alpha] ; break ;
			case 3	: color = [0.5, 0.49, 0.99, alpha] ; break ;
			case 4	: color = [0.84, 0.74, 0.43, alpha] ; break ;
			case 5	: color = [0.8, 0.9, 0.47, alpha] ; break ;
			case 6	: color = [0.93, 0.36, 0.72, alpha] ; break ;
			case 7	: color = [1., 0.79, 0.37, alpha] ; break ;
			case 8	: color = [1., 0.46, 0.46, alpha] ; break ;
			case 9	: color = [0.88, 0.86, 0.40, alpha] ; break ;
			case 10 : color = [0.67, 0.82, 0.57, alpha] ; break ;
			case 11 : color = [0.67, 0.83, 0.3, alpha] ; break ;
			}
		
		this.color = color ; 
	} ;
	
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

function default_channel (a)
    {
        if (a >= 1 && a <= 17)
            {
                seq.midi_channel = a ;
            }
    }

function set_tempo (a)                      
    {
        if (a >= 40 && a <= 300)
            { 
                seq.tempo = a ;
            }
    }

function size_window (a, b)                                                              
    {
        full_size = [a, b] ;
    }

function set_timesig (a, b)   
    {                                               
        if (a > 0 && (b === 4 || b === 8 || b === 16))
            {
                mygrid.time_sig	= [a, b] ;
                mybar.time_sig	= [a, b] ;
				
                mygrid.set_grid	() ;
                mybar.set_bar () ;
                mygrid.z_test (camera_z) ;
				
                store_pattr () ;
            }   
			 
        need_draw = 1 ;
    }

function my_name (a)
    {
		mytitle.myname = a ;
        mytitle.text (a) ;
		
		need_draw = 1 ;
    }
	
function window_resize ()
     { 
	 	var p = this.patcher ;
		
        if (jsarguments[1] !== "#0")
            {      
				myinfo.hide () ;
				mytitle.hide () ;
				key.pitch = 0 ;
				             
                myrender.erase () ;
                myrender.drawswap () ;

                if (!key.esc) 
                    {
                        window_buffer	= p.wind.location ;           
                        p.wind.location = [0, 44, full_size[0], full_size[1]] ;          
                        window_size		= [full_size[0], full_size[1] - 44] ;                         
                    }
                else
                    {
                       p.wind.location	= window_buffer ;
                       window_size		= [500, 400] ;
                    }

                key.esc = !key.esc ;
				
                messnamed (jsarguments[1] + "_jit_pwindow", "name", "temp_" + jsarguments[1]) ;     
                messnamed (jsarguments[1] + "_jit_pwindow", "size", p.wind.size) ;
                messnamed (jsarguments[1] + "_jit_pwindow", "name", js_name) ;                                                                                             
            
			    outlet (1, "resized") ; 
           }
    }
	
// -------------------------------------------------------------------------------------------------------------

function new_note (position, pitch, velocity, duration, channel)   
    {    
		seq.add_note (position, pitch, velocity, duration, channel) ; 
		                                    
        store_pattr () ;
        set_slow () ; 
		
		draw_sequence () ;
    }  

function clear ()                                                                    
    {
        seq.clear () ;
		
        store_pattr () ;
        set_slow () ;
		
		draw_sequence () ;
    }
	
function feedback_ghost ()                                                         
    {
		var i ;
	
		if (ghost.zut.length < MAX_NOTES)
			{
				seq.clear () ;
				
				for (i in ghost.zut)
					{ 
						seq.add_shape (ghost.zut[i]) ;
					}
				
				store_pattr () ;
				set_slow () ;
		
				draw_sequence () ;
			}		
    }

function ghost_set (position, pitch, velocity, duration, channel, un, deux, trois)   
    {          
		if (position !== 0 || pitch !== 0)
			{
				ghost.add (position, pitch, velocity, duration, channel, un, deux, trois) ;
			}
    }	
	
function ghost_clear ()                                                                                        
    {
        ghost.clear () ;
    }

function ghost_draw () 
	{
		draw_sequence () ;
	}
	
// -------------------------------------------------------------------------------------------------------------

function key_down_delete ()      
    { 
        if (!creating.state && mouse.where && !key.swap)               
            {	
				seq.delete_selected () ;
				
				store_pattr () ;
				set_slow () ;
				draw_sequence () ;
			}
	}

function key_down_swap ()
	{
        if (!creating.state && !seq.zut[0].select_right && !seq.zut[0].select_left && mouse.where) 
            {  
				key.swap  = !key.swap ; 
				draw_sequence () ;
			}                                                           
	}

function key_down_title ()
	{																								
       if (mouse.where)	                                                      
            { 	
				mytitle.displayed = !mytitle.displayed ;
				
				mytitle.text (mytitle.myname) ;
				
				if (mytitle.displayed) 
					{
						mytitle.show () ;
					}
				else 
					{
						mytitle.hide () ;
					}
					
				need_draw = 1 ;
			}  
	}

function key_down_ternary ()
	{
		var txt = "?" ;
		
        if (mouse.where)                  
            { 
				mygrid.ternaire = !mygrid.ternaire ; 
				
				mytitle.show () ;
				
				if (mygrid.ternaire)
					{
						switch (mygrid.snap) { 
							case 1 :    txt = "grille 8nt" ; break ;
							case 2 :    txt = "grille 16nt" ; break ;
							case 4 :    txt = "grille 32nt" ; break ;
						}
					}
				else
					{
						switch (mygrid.snap) { 
							case 1 :    txt = "grille 8n" ; break ;
							case 2 :    txt = "grille 16n" ; break ;
							case 4 :    txt = "grille 32n" ; break ;
						}
					}
				
				mytitle.text (txt) ;
				unpaste () ;
				
				store_pattr () ;
				need_draw = 1 ;
			}  
	}
     
function key_down_grid ()
	{
		var txt = "?" ;
		
        if (mouse.where)        
            {
                switch (mygrid.snap) { 
					case 1 :    mygrid.snap = 2 ; break ;
					case 2 :    mygrid.snap = 4 ; break ;
					case 4 :    mygrid.snap = 1 ; break ;
					}
					 
				mytitle.show () ;
				
				if (mygrid.ternaire)
					{
						switch (mygrid.snap) { 
							case 1 :    txt = "grille 8nt" ; break ;
							case 2 :    txt = "grille 16nt" ; break ;
							case 4 :    txt = "grille 32nt" ; break ;
						}
					}
				else
					{
						switch (mygrid.snap) { 
							case 1 :    txt = "grille 8n" ; break ;
							case 2 :    txt = "grille 16n" ; break ;
							case 4 :    txt = "grille 32n" ; break ;
						}
					}
				
				mytitle.text (txt) ;
				unpaste () ;
				
				store_pattr () ;
				need_draw = 1 ;
            }
	}

function key_down_reset ()
	{
	  	if (mouse.where)                              
            { 
				seq.reset () ; 
				
				mytitle.show () ;
				mytitle.text ("remise  zro") ;
				unpaste () ;
								
				store_pattr () ;
				need_draw = 1 ;
			}
	}
	
function key_down_snap ()
	{
        if (mouse.where)   
            {    
				key.snap =!key.snap ;
				
				mytitle.show () ;
			
				if (key.snap)
					{
						mytitle.text ("magntisme") ;
					}
				else
					{ 
						mytitle.text ("pas de magntisme") ;
					}
					
				unpaste () ;
				
				store_pattr () ;
				need_draw = 1 ;
            }
	}

function key_down_factor ()
	{
		if (mouse.where) 
			{
 				switch (seq.factor) { 
					case 1		: seq.factor = 10 ; break ;
					case 10		: seq.factor = 100 ; break ;
					case 100	: seq.factor = 1000 ; break ;
					case 1000	: seq.factor = 1 ; break ;
					}
					 
				mytitle.show () ;
				mytitle.text ("x " + seq.factor) ;	
				unpaste () ;
				
				need_draw = 1 ;
			}
	}

function key_down_pitch ()
	{
        if (mouse.where)   
            {
				key.pitch = !key.pitch ;
				
				if (!key.pitch)
					{
						myinfo.hide () ;
						need_draw = 1 ;
					}	
			}
	}

function key_down_position ()
	{
        if (mouse.where)   
            {
				key.position = !key.position ;
			}
	}
	
function key_down_one ()
	{
        if (mouse.where && !(key.un + key.deux + key.trois + key.quatre))  
            {   
				key.un = 1 ; 
			}
	}

function key_down_two ()
	{
        if (mouse.where && !(key.un + key.deux + key.trois + key.quatre))  
            {   
				key.deux = 1 ; 
			}
	}

function key_down_three ()
	{
        if (mouse.where && !(key.un + key.deux + key.trois + key.quatre))  
            {  
			 	key.trois = 1 ; 
			}
	}

function key_down_four ()
	{
        if (mouse.where && !(key.un + key.deux + key.trois + key.quatre))  
            {  
				key.quatre = 1 ; 
			}
	}

function key_up ()
    {
        if (!mouse.moving)
            { 
				key.reset () ; 
              	outlet (1, "key_up") ; 
			}
    }
	
// -------------------------------------------------------------------------------------------------------------

function wheel_v (a)
	{
		var i ;
		
		myinfo.hide () ;
		
		for (i = 0 ; i < 4 ; i++)
			{
				if (a)
					{
						up.execute () ;
					}
				else
					{
						down.execute () ;
					}
			}
}
	
function wheel_h (a)
	{
		var i ;
		
		myinfo.hide () ;
		
		for (i = 0 ; i < 4 ; i++)
			{
				if (a)
					{
						left.execute () ;
					}
				else
					{
						right.execute () ;
					}
			}
	}

function wheel_z (a)
	{
		var i ;
		
		mytitle.text (" ") ;
		myinfo.hide () ;
		key.pitch = 0 ;
		
		for (i = 0 ; i < 4 ; i++)
			{
				if (a)
					{
						zoom.execute () ;
					}
				else
					{
						unzoom.execute () ;
					}
			}
		
		unpaste () ;
	}
	
// -------------------------------------------------------------------------------------------------------------

function pomme_a ()                                         
    {
        if (mouse.where && !creating.state && !mouse.moving && !key.swap)                                              
            {
                seq.select_all () ;
				draw_sequence () ;
            }
    }

function pomme_c ()
    {
		var i ;
		
        if (mouse.where && !key.swap && !creating.state && !mouse.moving)
            {
				tralala_pomme.splice (0, tralala_pomme.length) ;
				
				k = seq.to_pomme () ;
				
				for (i in k) 
					{
						tralala_pomme.push (k[i]) ;
					}	
            }

        if (mouse.where && key.swap && !creating.state && !mouse.moving)
            {
                tralala_pomme.splice (0, tralala_pomme.length) ;
				
				k = ghost.to_pomme () ;
				
				for (i in k) 
					{
						tralala_pomme.push (k[i]) ;
					}	                        
            }
    }

function pomme_v () 
    {
         if (mouse.where && !creating.state && !mouse.moving && !key.swap) 
            {
				seq.unselect_all () ;
				
                seq.from_pomme (tralala_pomme) ;
				
                store_pattr () ;
                set_slow () ;
				draw_sequence () ;
            }
    }

function pomme_x ()
    {
        if (mouse.where && !creating.state && !mouse.moving && !key.swap)
            {
                pomme_c () ;
				
                seq.delete_selected () ;
				
				store_pattr () ;
                set_slow () ;
				draw_sequence () ;
            }
    }
	
// -------------------------------------------------------------------------------------------------------------
	
function player_position (a)                                                                   
    {         
        if (key.swap)                                                     
            {
				var k = (((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * a) - SCALE_X ;
				var z = ghost.match (k) ;
			    
				if (z)
               		{
						draw_sequence () ;
                    }
            }
    }
	
function start_position (a)                                                
    {
        if (a === "reset")
            {
                ghost.start = seq.zut[0].x ;
            }
        else
            {                                 
                ghost.start = min_snap ((((2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP)) * a) - SCALE_X) ;  
            }
    }

// -------------------------------------------------------------------------------------------------------------

function write (a)                                                            
    {
		var ligne ;
		var a, b, c, d, e ;
		var i, len ;
		
        var fichier		= new File (a, "write", "TEXT") ;
        var temp		= [ ] ;
        var start_end	= seq.translate_zone () ;
        var k			= TEMPO_CST / seq.tempo ;
		var n			= [ ] ;

		for (i = 1, len = seq.zut.length ; i < len ; i++)
            { 
                n = seq.translate_shape (i) ;
                if (n[0] >= start_end[0] && n[0] <= start_end[1])
                    {
                        a = Math.round ((n[0] - start_end[0]) * k) ;
                        b = n[1] ;
                        c = n[2] ;
                        d = Math.round ((n[8] - start_end[0]) * k) ;
                        e = n[4] + 143 ;

                        temp.push ([a, e, b, c]) ;
                        temp.push ([d, e, b, 0]) ;
                    }
            }
			
        temp.sort (compare_time) ;

        fichier.open (a) ;
		
        if (fichier.eof) 
            {
                fichier.eof = 0 ;
            }
			
        for (i in temp)
            {
                ligne = temp[i].join (" ") ;
                fichier.writeline (ligne + ";") ;
            }
			
        fichier.close () ;
    }

function read (a)
    {
		var ligne, scrap, nombres, data ;
		var position, pitch, velocity, duration, channel ;
		var i, j ;
		
        var fichier	= new File (a, "read", "TEXT") ;
		var temp	= [ ] ;
		var buffer	= [ ] ;
		var k		= TEMPO_CST / seq.tempo ;
		var l		= Math.round (((seq.zut[0].x + SCALE_X) * SEQ_BAR_LONG * TIME_STEP) / (2 * SCALE_X)) ;

        fichier.open (a) ;

        if (fichier.isopen)
            {
				seq.clear () ;

                while (ligne = fichier.readline ()) 
                    { 
                        scrap	= ligne.length - ligne.search (" ;|;") ;
                        nombres = ligne.slice (0, -scrap) ;
                        data	= nombres.split (" ") ;
						
                        if (data.length === 4 && data[1] > 143 && data[1] < 160)
                            {
                                temp.push (data) ;
                            }
                    } 
					
                temp.sort (compare_time) ;
				
                for (i in temp)
                    { 
						if (temp[i][3] != 0) 
                            { 
								buffer.push (temp[i]) ; 
							}
						else
                            { 
                                for (j in buffer)
                                    {
                                       if (temp[i][1] === buffer[j][1] && temp[i][2] === buffer[j][2])
                                           {
                                                position	= Math.round (buffer[j][0] / k) + l ;
                                                pitch		= Math.round (buffer[j][2]) ;
                                                velocity	= Math.round (buffer[j][3]) ;
                                                duration	= Math.round ((temp[i][0] - buffer[j][0]) / k) ;
                                                channel		= Math.round (buffer[j][1] - 143) ;
												
                                                seq.add_note (position, pitch, velocity, duration, channel) ;
                                                buffer.splice (j, 1) ;
                                            }
                                      }        
                            }          
                   } 
				   
                seq.zut[0].u = seq.zut[seq.zut.length - 1].u ;
				
                store_pattr () ;
                draw_sequence () ;  
            }  

        fichier.close () ;
		
        set_matrix () ;
        outlet (1, "recalled") ;
    }	

function getvalueof ()
    {
		var i ;
        var pattr = [ ] ;         

        pattr.push (mygrid.ternaire) ;                                    
        pattr.push ("rien") ; 
        pattr.push ("rien") ; 
        pattr.push ("rien") ; 
        pattr.push (camera_x) ;                                        
        pattr.push (camera_y) ;
        pattr.push (camera_z) ;
        pattr.push (mygrid.time_sig[0]) ;                                       
        pattr.push (mygrid.time_sig[1]) ;
        pattr.push (mygrid.snap) ;
        pattr.push (key.snap) ;

        for (i in seq.zut)                                                             
            {                                                                                 
                pattr.push (seq.zut[i].x) ;                                  
                pattr.push (seq.zut[i].y) ;
                pattr.push (seq.zut[i].u) ;
                pattr.push (seq.zut[i].v) ;
                pattr.push (seq.zut[i].alpha) ;
                pattr.push (seq.zut[i].channel) ;
                pattr.push (seq.zut[i].un) ;
                pattr.push (seq.zut[i].deux) ;
                pattr.push (seq.zut[i].trois) ;  
            }

         return pattr ;
    }

function setvalueof ()
    {
        var a = arrayfromargs (arguments) ;
        var b = (a.length- 11) / 9 ;  
		var x, y, u, v, alpha, channel, un, deux, trois ;    
		var i ;                                                 
        
        seq.zut.splice (0, seq.zut.length) ;

        mygrid.ternaire		= a[0] ; 
        camera_x			= a[4] ;                                            
        camera_y			= a[5] ;
        camera_z			= a[6] ;
        mygrid.time_sig[0]	= a[7] ;
		mybar.time_sig[0]	= a[7] ;
        mygrid.time_sig[1]	= a[8] ;
		mybar.time_sig[1]	= a[8] ;
        mygrid.snap			= a[9] ;
        key.snap			= a[10] ;

        for (i = 0 ; i < b ; i++) 
            {
                x		= a[(i * 9) + 11] ;
                y		= a[(i * 9) + 12] ;
                u		= a[(i * 9) + 13] ;
                v		= a[(i * 9) + 14] ;
                alpha	= a[(i * 9) + 15] ;
                channel = a[(i * 9) + 16] ;
                un		= a[(i * 9) + 17] ;
                deux	= a[(i * 9) + 18] ;
                trois	= a[(i * 9) + 19] ;
                
                if (i < MAX_NOTES)
                    {
                        seq.zut[i] = new Shape (x, y, u, v, alpha, 0, channel, un, deux, trois) ;
						seq.zut[i].paint_values () ;
                    }
					
				seq.zut[0].select_right = 0 ;
    			seq.zut[0].select_left	= 0 ; 
            }
                               
        set_matrix () ;
        outlet (1, "recalled") ;

        mygrid.set_grid () ;
		mybar.set_bar () ;
        camera_pos (camera_x, camera_y, camera_z) ;
        mygrid.z_test (camera_z) ;

        draw_sequence () ;   
   }
   
// -------------------------------------------------------------------------------------------------------------

function redraw ()                                                  
    {
		mytitle.show () ;
		mytitle.text (" ") ;
		unpaste () ;
			
        myrender.erase () ;
        myrender.drawswap () ;
		
		need_draw = 1 ;
    }

function bang ()
    {
        if (noname)
            { 
				if (jsarguments[1] !== "#0")
					{
						messnamed (jsarguments[1] + "_jit_pwindow", "name", js_name) ;
						camera_pos (camera_x, camera_y, camera_z) ; 
						mygrid.z_test (camera_z) ;
						mygrid.set_grid () ;
						mybar.set_bar () ;
						draw_sequence () ;		
					}
					
                noname = 0 ; 
            }

        if (need_draw) 
            {
                myrender.erase () ;
                mytitle.draw () ;
                myinfo.draw () ;
                mygrid.draw () ;
                mybar.draw () ;
                mypaint_multiple.draw () ;
                myrender.drawswap () ;

                need_draw = 0 ;
            }
    }
	
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

camera_pos.local = 1 ;
function camera_pos (a, b, c) 
    {
        var x = c - 100 ;
		
        myrender.camera = [a, b, c] ;
        myrender.lookat = [a, b, x] ;

        mytitle.position = [a, b, 0.] ;           
    }    

move_camera_auto.local = 1 ;
function move_camera_auto (x, y)
	{
		var h = window_size[0] - 15 ;        
		var p = window_size[1] - 15 ; 
		   
		if (x < 15) 
			{ 
				k = 1 ;
				left.execute () ; 
			} 
		if (x > h) 
			{ 
				k = 1 ;
				right.execute () ;
			} 
		if (y < 15) 
			{ 
				k = 1 ;
				up.execute () ; 
			}
		if (y > p) 
			{ 
				k = 1 ;
				down.execute () ; 
			}  	
	}
	
move_camera_right.local = 1 ;
function move_camera_right ()
    {
        if (camera_x < SCALE_X)
            {
                camera_x += 0.02 * camera_z ;              
                camera_pos (camera_x, camera_y, camera_z) ;  
				          
                need_draw = 1 ;
				store_pattr () ; 
			}
    }

move_camera_left.local = 1 ;
function move_camera_left ()
    {
        if (camera_x > -SCALE_X)
            {
                camera_x -= 0.02 * camera_z ;
                camera_pos (camera_x, camera_y, camera_z) ;
				
                need_draw = 1 ;
                store_pattr () ; 
            }
    }

move_camera_up.local = 1 ; 
function move_camera_up ()
    {
        if (camera_y < SCALE_Y)
            {
                camera_y += 0.02 * camera_z ;
                camera_pos (camera_x, camera_y, camera_z) ;
				
                need_draw = 1 ;
                store_pattr () ; 
            }
    }

move_camera_down.local = 1 ;
function move_camera_down ()
    {
        if (camera_y > -SCALE_Y)
            {
                camera_y -= 0.02 * camera_z ;
                camera_pos (camera_x, camera_y, camera_z) ;
				
                need_draw = 1 ;
                store_pattr () ; 
            }
    }

move_camera_unzoom.local = 1 ;
function move_camera_unzoom ()
    { 
        if (camera_z < 2.)                                                               
            {                                                                                 
                camera_z += 0.02 ;
                camera_pos (camera_x, camera_y, camera_z) ;
                mygrid.z_test (camera_z) ;
                
				need_draw = 1 ;
				store_pattr () ;
            }
    }

move_camera_zoom.local = 1 ;
function move_camera_zoom ()
    {
        if (camera_z > 0.15)
            {
                camera_z -= 0.02 ;
                camera_pos (camera_x, camera_y, camera_z) ;
                mygrid.z_test (camera_z) ;
				
                need_draw = 1 ;
				store_pattr () ;
            }
    }
	
// -------------------------------------------------------------------------------------------------------------

snap_up.local = 1 ;
function snap_up (a)                                                    
    { 
		return ((Math.ceil ((a + SCALE_Y) / SCALE_STEP)) * SCALE_STEP) - SCALE_Y ; 
	}      

snap_down.local = 1 ;
function snap_down (a)
    { 
		return ((Math.floor ((a + SCALE_Y) / SCALE_STEP)) * SCALE_STEP) - SCALE_Y ; 
	}

snap_grid.local = 1 ;
function snap_grid (a, how)
    { 
       var b, k ;

       if (!mygrid.ternaire)
            { 
               switch (mygrid.time_sig[1])
                   {
                        case 1	: b = 4 * mygrid.snap ; break ;            
                        case 2	: b = 4 * mygrid.snap ; break ;
                        case 4	: b = 2 * mygrid.snap ; break ;
                        case 8	: b = 2 * mygrid.snap ; break ;
                        default : b = 2 * mygrid.snap ; break ;
                   }
            }
		else            
			{
                switch (mygrid.time_sig[1])
                   {
                        case 1	: b = 3 * mygrid.snap ; break ;
                        case 2	: b = 3 * mygrid.snap ; break ;
                        case 4	: b = 3 * mygrid.snap ; break ;
                        case 8	: b = 3 * mygrid.snap ; break ;
                        default : b = 3 * mygrid.snap ; break ;
                   }
            }

		k = (2 * SCALE_X) / (SEQ_BAR_LONG * mygrid.time_sig[1] * b) ;
	   
		if (how === "left")
			{
				return ((Math.floor ((a + SCALE_X) / k)) * k) - SCALE_X ;
			}
		
		if (how === "right")
			{
				return ((Math.ceil ((a + SCALE_X) / k)) * k) - SCALE_X ;
			}

		return ((Math.round ((a + SCALE_X) / k)) * k) - SCALE_X ;  

	}

min_snap.local = 1 ;                                                          
function min_snap (a)
    {
        var k = (2 * SCALE_X) / (SEQ_BAR_LONG * TIME_STEP) ;
        return ((Math.round ((a + SCALE_X) / k)) * k) - SCALE_X ;   
    }
// -------------------------------------------------------------------------------------------------------------

unpaste.local = 1 ;
function unpaste () 
	{
		if (slow_unpaste.running)
			{ 
				slow_unpaste.cancel () ; 
			}  	
					
		slow_unpaste.schedule (2000) ;
	}

unpaste_mytitle.local = 1 ;
function unpaste_mytitle ()
	{
		if (mytitle.displayed)
			{
				mytitle.text (mytitle.myname) ;
			}
		else
			{
				mytitle.hide () ;
			}
			
		need_draw = 1 ;
	}	
	
// -------------------------------------------------------------------------------------------------------------

store_pattr.local = 1 ;
function store_pattr ()
    {
        if (slow_notify.running)
            { 
				slow_notify.cancel () ;
			}                        

        slow_notify.schedule (500) ;                                                                            
    }

// -------------------------------------------------------------------------------------------------------------

set_slow.local = 1 ;
function set_slow ()
    {
        if (slow_set.running)
            { 
				slow_set.cancel () ; 
			}                        

        slow_set.schedule (100) ;    
    }
        
set_matrix.local = 1 ;
function set_matrix ()
    { 
		var i, len ;
		var matrix_dim	= seq.zut.length - 1 ;                 
        var start_end	= seq.translate_zone () ;   
		var a			= [ ] ; 
       
		if (slow_set.running)
            { 
				slow_set.cancel () ; 
			}
	   
        outlet (0, "notes_number", matrix_dim) ;                                 

        for (i = 1, len = seq.zut.length ; i < len ; i++)             
            {
                a = seq.translate_shape (i) ;              
                outlet (0, "matrix", "setcell", i - 1, "val", a) ;
            }

         if (matrix_dim === 0)
         	{ 
				outlet (0, "matrix", "setall", 0) ; 
			}    

        outlet (0, "loop", "start", start_end[0]) ;                                  
        outlet (0, "loop", "end",	start_end[1]) ;
	}
	
// -------------------------------------------------------------------------------------------------------------
	
compare_time.local = 1 ;
function compare_time (a, b)
    {
        if (a[0] - b[0] < 0)
            { return -1 ; }
			
        if (a[0] - b[0] > 0)
            { return 1 ; }
			
        if (a[0] - b[0] === 0)
            {
                if (a[3] - b[3] < 0)
					{ return -1 ; }
                if (a[3] - b[3] > 0)
					{ return 1 ; }
                if (a[3] - b[3] === 0)
					{ return 0 ; }
            }
    }
	
// -------------------------------------------------------------------------------------------------------------

draw_sequence.local = 1 ;
function draw_sequence ()
	{
		var k, i, len, couleur ;
		var temp = [ ] ;
	
		if (!key.swap)                                                  
			{
				mypaint_nothing.poly_mode = [0, 0] ; 
				
				if (seq.lasso_state)
					{ k = seq.zut.length + 1 ; }
				else
					{ k = seq.zut.length ; }
					
				mypaint_position.dim	= k ;
				mypaint_scale.dim		= k ;
				mypaint_color.dim		= k ;

				mypaint_position.setcell	(0, "val", (seq.zut[0].x + seq.zut[0].u) / 2., (seq.zut[0].y + seq.zut[0].v) / 2.) ;
				mypaint_scale.setcell		(0, "val", (seq.zut[0].u - seq.zut[0].x) / 2., (seq.zut[0].v - seq.zut[0].y) / 2.) ;
				
				if (seq.zut[0].select)
					{
						mypaint_color.setcell (0, "val", 0., 0., 0., 0.1) ;
					}
				else
					{
						mypaint_color.setcell (0, "val", 0.7, 0.7, 0.7, 0.1) ;
					}	
				
				for (i = 1, len = seq.zut.length ; i < len ; i++)
					{
						mypaint_position.setcell	(i, "val", seq.zut[i].a, seq.zut[i].b) ;
						mypaint_scale.setcell		(i, "val", seq.zut[i].c, seq.zut[i].d) ;
						
						if (seq.zut[i].select)
							{
								couleur = [0.5, 0.5, 0.5, seq.zut[i].color[3]] ;
							}
						else
							{
								couleur = seq.zut[i].color ;
							}
							
						mypaint_color.setcell (i, "val", couleur) ;
					}
				
				if (seq.lasso_state)
					{
						mypaint_position.setcell	(k - 1, "val", (seq.lasso_x + seq.lasso_u) / 2., (seq.lasso_y + seq.lasso_v) / 2.) ;
						mypaint_scale.setcell		(k - 1, "val", (seq.lasso_u - seq.lasso_x) / 2., (seq.lasso_v - seq.lasso_y) / 2.) ;
						mypaint_color.setcell		(k - 1, "val", 0., 0.62, 0.93, 0.1) ;
					}
			}
		else
			{
				mypaint_nothing.poly_mode = [1, 1] ; 
				
				mypaint_position.setall		(0) ;
				mypaint_scale.setall		(0) ;
				mypaint_color.setall		(0) ;
				
				mypaint_position.dim	= ghost.zut.length ;
				mypaint_scale.dim		= ghost.zut.length ;
				mypaint_color.dim		= ghost.zut.length ;	
				
				k = 0 ;
				
				for (i = 0, len = ghost.zut.length ; i < len ; i++)                          
					{ 
						if (ghost.zut[i].select)
							{
								temp.push (ghost.zut[i]) ;      
							}                                                     
						else
							{
								mypaint_position.setcell	(k, "val", ghost.zut[i].a, ghost.zut[i].b) ;
								mypaint_scale.setcell		(k, "val", ghost.zut[i].c, ghost.zut[i].d) ;
								mypaint_color.setcell		(k, "val", ghost.zut[i].color) ;						
								k ++ ;
							}
					}
					
				for (i in temp)
					{
						mypaint_position.setcell	(k, "val", temp[i].a, temp[i].b) ;
						mypaint_scale.setcell		(k, "val", temp[i].c, temp[i].d) ;
						mypaint_color.setcell		(k, "val", 0., 0., 0., temp[i].color[3]) ;
						k ++ ;
					}
			}
		
		mypaint_multiple.position_matrix	("position" + js_name) ;
		mypaint_multiple.scale_matrix		("scale" + js_name) ;
		mypaint_multiple.color_matrix		("color" + js_name) ;
		
		need_draw = 1 ;
	}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

callback.local = 1 ;
function callback (event)
	{ 
		var x, y, click, cmd, shift, option, caps, ctrl ;
		var k, l, w, z ;
		var alpha, mouse_now, step ;
		
		var a = [undefined, undefined] ;

	
        if (event.eventname === "mouse")
            { 
                x		= event.args[0] ;
                y		= event.args[1] ;
                click	= event.args[2] ;
                cmd		= event.args[3] ;
                shift	= event.args[4] ;
				caps	= event.args[5] ;
                option	= event.args[6] ;
				ctrl	= event.args[7] ;
				
                a		= myrender.keep_inside (x, y) ;
   				
				seq.coordinates		= a ;
				ghost.coordinates	= a ;
				
				if (key.pitch) 
					{
						myinfo.show () ;
						myinfo.paste (a[0], a[1], "pitch") ;
						need_draw = 1 ;
					}

				if (click && shift && !seq.lasso_state && !option && !key.swap && !cmd && !creating.state)   // select, unselect shape with shift.
					{
						k = seq.is_hit (a[0], a[1]) ;  
						
						if (k[0] === "selected")
							{
								seq.zut[k[1]].select = 0 ;
							}
						if (k[0] === "unselected")  
							{
								seq.zut[k[1]].select = 1 ;
							}
						                          
						draw_sequence () ;
					}     

				if (click && !shift && !creating.state && !seq.zut[0].select && !seq.lasso_state && !key.swap && !seq.lasso_block)  // mouse hit.    
					{
						k = seq.is_hit (a[0], a[1]) ;
						
						if (k[0] === "selected")
							{
								if (!mouse.hit)                                    
									{
										seq.compute_delta () ;	
										seq.zut[k[1]].mark = 1 ;
										mouse.hit = 1 ;
									}      
							}
							
						if (k[0] === "unselected")
                            {
								if (!mouse.moving)
									{
										seq.unselect_all () ;
										seq.zut[k[1]].select = 1 ;
										seq.zut[k[1]].mark = 1 ;
										seq.compute_delta () ;
                                        mouse.avoid_up = 1 ;
                                        seq.lasso_block = 1 ;
                                        mouse.hit = 1 ; 
										 
                                        draw_sequence () ;
                                     }
                            }                    
    				}

				if (click && !mouse.hit && !cmd && !creating.state && !option && !key.swap && !seq.lasso_block)    // lasso.       
					{
						if (!seq.lasso_x)                                           
							{ 
								seq.lasso_state = 1 ; 
								seq.lasso_x	= a[0] ; 
                                seq.lasso_y	= a[1] ; 
							}  
               
						seq.lasso_u = a[0] ;                            
						seq.lasso_v = a[1] ;
						
						if (seq.lasso_x === seq.lasso_u)                        
							{    
								k = seq.exist_selected () ;
								
								if (k)
									{
										mouse.avoid_up = 1 ;
									}                                          
 								if (!shift)
									{ 
										seq.unselect_all () ; 
									}
							}
                     	else
							{
								mouse.avoid_up = 1 ;
								draw_sequence () ;
							}						
					}
              
				if (!click && !cmd && !shift && !mouse.avoid_up && !key.swap)  // select zone.
					{                                                                                                  
						w = Math.abs (seq.zut[0].x - a[0]) ;                
						z = Math.abs (seq.zut[0].u - a[0]) ;

						if (seq.zut[0].select)                         
							{ 
								seq.zut[0].select = 0 ;
								seq.zut[0].select_right = 0 ;
                                seq.zut[0].select_left = 0 ;
								seq.zut[0].sort () ;
								draw_sequence() ;
								store_pattr () ;
								set_slow () ;
							}
						else                                           
							{ 
								if (z < 0.01)
									{
										seq.zut[0].select = 1 ;
										seq.zut[0].select_right = 1 ; 
                                        seq.zut[0].select_left = 0 ;
                                        draw_sequence () ; 
									}
								else
									{
										if (w < 0.01)
                                        	{ 
												seq.zut[0].select = 1 ;
                                            	seq.zut[0].select_right = 0 ; 
                                                seq.zut[0].select_left = 1 ;
                                                draw_sequence () ;
											}
                                    }
							}
					}  

				if (cmd && click && !creating.state && !creating.block && !key.swap && !option && !mouse.hit && !seq.zut[0].select)  // create shape (start).
					{
						k = a[0] ;
						
						if (seq.zut.length < MAX_NOTES && k + 0.001 < SCALE_X)
							{
								alpha = 90 * (1 / MIDI) ;
								creating.state = 1 ;
								creating.block = 1 ;
								
								if (key.snap || ctrl)
									{
										k = snap_grid (a[0], "left") ;
										
										switch (mygrid.snap) {
											case 1 : l = snap_grid (k + 0.012, "right") ; break ;
											case 2 : l = snap_grid (k + 0.006, "right") ; break ;
											case 4 : l = snap_grid (k + 0.003, "right") ; break ;
											}
									}
								else
									{
										l = min_snap (k + 0.0015) ;
									}
								
								seq.zut[seq.zut.length] = new Shape (min_snap (k), snap_up (a[1]), l, snap_down (a[1]), alpha, 1, seq.midi_channel, 0, 0, 0) ;
								seq.zut[seq.zut.length - 1].paint_values () ;
								draw_sequence () ;
							}
					}   

				if (click && creating.state && !creating.block && !key.swap && !option && !shift)    // create shape (end).
					{
						creating.state = 0 ; 
						mouse.avoid_up = 1 ;
						creating.block = 1 ;
						seq.zut[seq.zut.length - 1].select = 0 ;
						seq.zut[seq.zut.length - 1].sort () ;
						seq.zut[seq.zut.length - 1].paint_values () ;
						store_pattr () ;
						set_slow () ;
						draw_sequence () ;
					} 

				if (!click && !key.swap)     // mouse up.                                                      
					{
						if (seq.lasso_state)
							{
								seq.lasso_select () ;
							}
							
						seq.lasso_state		= 0 ; 
						mouse.avoid_up		= 0 ;
						creating.block		= 0 ;
						seq.buffer			= null ;
						seq.lasso_x			= null ;
						seq.lasso_y			= null ;
						seq.lasso_u			= null ;
						seq.lasso_v			= null ;
						mouse.hit			= 0 ;
						seq.lasso_block		= 0 ;
						mouse.moving		= 0 ;
						
						seq.lasso_reverse () ;  
						seq.unmark () ; 
						
						if (!key.pitch) 
							{
								myinfo.hide () ;
							}
												
						draw_sequence () ;
					}

				if (mouse.hit && !option && !key.swap && !(key.un + key.deux + key.trois + key.quatre))   // move shape.
					{ 
						mouse.moving = 1 ; 
						mouse.avoid_up = 1 ;	
						
						move_camera_auto (x, y) ;               

						if (key.snap || ctrl)
							{
								seq.move_selected (a[0], a[1], 1) ;
							}
						else
							{
								seq.move_selected (a[0], a[1], 0) ;
							}
								
						draw_sequence () ;    
						store_pattr () ;
						set_slow () ;
					}

				if (mouse.hit && option && !key.swap && !cmd)  // resize shape.
     				{
						mouse.avoid_up	= 1 ;
						mouse.moving	= 1 ;
						
						move_camera_auto (x, y) ;
						
						if (key.snap || ctrl)
							{
								seq.resize_selected (a[0], 1) ;
							}
						else
							{
								seq.resize_selected (a[0], 0) ;
							}

       					draw_sequence () ;
        				store_pattr () ;
        				set_slow () ;
    				}

				if (mouse.hit && option && cmd && !key.swap)         // change velocity.  
					{                                                                                       
						mouse_now	= a[1] ;     
						step		= (1 / MIDI) * Math.round (camera_z * 5) ; 
						k			= seq.whois_mark () ;      
                        
						if (key.pitch) { key.pitch = 0 ; }
						
						mouse.moving	= 1 ;
						mouse.avoid_up	= 1 ;
						seq.change_selected ("alpha", step, mouse_now, caps, k) ;
                        seq.buffer = mouse_now ;
						
						myinfo.show () ;
						myinfo.paste (a[0], a[1], "alpha", seq.zut[k]) ;
						
						draw_sequence () ;
						store_pattr () ;
						set_slow () ;
					}
                         
				if (mouse.hit && !option && !cmd && !key.swap)    // change channel, un, deux, trois.    
					{    
						k			= seq.whois_mark () ;                                                      
						mouse_now	= a[1] ;  
						step		= seq.factor ;
						
						mouse.moving = 1 ;                  
						
						if (key.un)
							{
								mouse.avoid_up = 1 ;
								if (key.pitch) { key.pitch = 0 ; }
								myinfo.show () ;
                            	seq.change_selected ("channel", 1, mouse_now, caps, k) ;
								myinfo.paste (a[0], a[1], "channel", seq.zut[k]) ;
								need_draw = 1 ;
							}
							
						if (key.deux)
							{
								mouse.avoid_up = 1 ;
								if (key.pitch) { key.pitch = 0 ; }
								myinfo.show () ;
                            	seq.change_selected ("un", step, mouse_now, caps, k) ;
								myinfo.paste (a[0], a[1], "un", seq.zut[k]) ;
								need_draw = 1 ;
							}
							
						if (key.trois)
							{
								mouse.avoid_up = 1 ;
								if (key.pitch) { key.pitch = 0 ; }
								myinfo.show () ;
                            	seq.change_selected ("deux", step, mouse_now, caps, k) ;
								myinfo.paste (a[0], a[1], "deux", seq.zut[k]) ;
								need_draw = 1 ;
							}
							
						if (key.quatre)
							{
								mouse.avoid_up = 1 ;
								if (key.pitch) { key.pitch = 0 ; }
								myinfo.show () ;
                            	seq.change_selected ("trois", step, mouse_now, caps, k) ;
								myinfo.paste (a[0], a[1], "trois", seq.zut[k]) ;
								need_draw = 1 ;
							}
							
						seq.buffer = mouse_now ;
						
						store_pattr () ;
						set_slow () ;
					}  
			}  

		if (event.eventname === "mouseidle")
			{ 
                x		= event.args[0] ;
                y		= event.args[1] ;
                cmd		= event.args[3] ;
                shift	= event.args[4] ;
				caps	= event.args[5] ;
                option	= event.args[6] ;
				ctrl	= event.args[7] ;
				
                a		= myrender.keep_inside (x, y) ;

                seq.coordinates		= a ;
				ghost.coordinates	= a ;
				
				if (key.pitch) 
					{
						myinfo.show () ;
						myinfo.paste (a[0], a[1], "pitch") ;
						need_draw = 1 ;
					}
						
				if (seq.zut[0].select_right && !key.swap)   // moving zone.
					{     
						move_camera_auto (x, y) ;
                           
						if (key.snap || ctrl) 
							{ 
								seq.zut[0].u = snap_grid (a[0]) ;
							}
						else
							{
								seq.zut[0].u = min_snap (a[0]) ;
							}
							
						draw_sequence () ;
					}
                 
				if (seq.zut[0].select_left && !key.swap)   // moving zone.
					{
						move_camera_auto (x, y) ;
                           
						if (key.snap || ctrl) 
							{ 
								seq.zut[0].x = snap_grid (a[0]) ;
							}
						else
							{
								seq.zut[0].x = min_snap (a[0]) ;
							}
								
						draw_sequence () ;
					}

				if (creating.state && !key.swap)   // creating shape.
					{
						move_camera_auto (x, y) ;  
                        
						if (key.snap || ctrl)
							{
								seq.zut[seq.zut.length - 1].u = snap_grid (a[0], "right") ; 
								seq.zut[seq.zut.length - 1].paint_values () ;
							}
						else 
							{         
								seq.zut[seq.zut.length - 1].u = min_snap (a[0]) ; 
								seq.zut[seq.zut.length - 1].paint_values () ;
							}
							
						draw_sequence () ;
					}
   
				if (!mouse.where) // mouse is there.
					{
						mouse.where = 1 ;  
						this.patcher.wind.bringtofront () ;
					}

			}
 
		if (event.eventname === "mouseidleout")    // mouse is out !
			{ 
				mouse.where	= 0 ; 
				key.pitch	= 0 ;
				myinfo.hide () ; 
				
				need_draw = 1 ;                                                                                        
            }
			
   }

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x